max v2;
#N vpatcher 170 190 1032 780;
#P origin 51 0;
#P window setfont "Sans Serif" 14.;
#P window linecount 4;
#P comment 320 266 264 196622 warning: an Andrew May patch \; cemi.music.unt.edu/may \; andrew.may@unt.edu \; last revised October 10 \, 2011;
#P window linecount 12;
#P comment 204 352 624 196622 audio_safety~ \; \; this is a tool to save your ears and your speakers from serious harm \; it is recommended to use it before audio outputs and on the outputs and/or recirculation lines of potentially unstable audio processes \; it's also good when you suspect that control events for audio processes (particularly filters) may be producing junk data \; it's a good idea to put a scope~ on the same source you are sending to audio_safety~ when testing \, since this patch can mask serious problems in your audio patch \; \; not warrantied in any way - no guarantees of fitness for any purpose \, reasonable or unreasonable;
#P window linecount 1;
#P newex 199 58 39 196622 r $1;
#P objectname u921000001[1];
#N vpatcher 320 44 989 854;
#P window setfont "Sans Serif" 14.;
#P window linecount 0;
#P newex 426 276 30 196622 t b;
#P window linecount 1;
#P newex 446 212 44 196622 == 0;
#P newex 426 247 42 196622 gate;
#P newex 378 247 42 196622 gate;
#P newex 446 177 48 196622 >= 1.;
#P newex 410 141 36 196622 t f f;
#P newex 178 520 78 196622 change 1.;
#P message 296 536 26 196622 70;
#P message 267 536 26 196622 10;
#P newex 280 507 58 196622 sel 0 1;
#P newex 178 581 75 196622 pack 1. 0;
#P newex 280 480 38 196622 < 1.;
#P newex 224 428 46 196622 t f f f;
#P outlet 124 737 15 0;
#P inlet 187 27 15 0;
#P message 426 307 17 196622 1;
#P flonum 224 383 112 14 0 0 0 3 0 0 0 221 221 221 222 222 222 0 0 0;
#P newex 124 689 27 196622 *~;
#P newex 178 624 57 196622 line~ 1;
#P newex 224 347 100 196622 expr 1. / $f1;
#P newex 409 115 44 196622 / 0.9;
#P newex 409 84 105 196622 peakamp~ 10;
#P connect 7 0 4 0;
#P connect 4 0 8 0;
#P connect 3 0 4 1;
#P connect 9 1 15 0;
#P connect 15 0 11 0;
#P connect 11 0 3 0;
#P connect 18 0 2 0;
#P connect 6 0 2 0;
#P connect 2 0 5 0;
#P connect 5 0 9 0;
#P connect 14 0 11 1;
#P connect 13 0 11 1;
#P connect 12 0 13 0;
#P connect 9 2 10 0;
#P connect 10 0 12 0;
#P connect 12 1 14 0;
#P connect 9 0 10 1;
#P connect 17 0 18 0;
#P connect 7 0 0 0;
#P connect 0 0 1 0;
#P connect 1 0 16 0;
#P connect 16 0 18 1;
#P connect 20 0 19 0;
#P connect 19 0 21 0;
#P connect 21 0 6 0;
#P connect 16 1 17 0;
#P connect 17 0 20 0;
#P connect 16 0 19 1;
#P pop;
#P newobj 110 176 65 196622 p limiter;
#P newex 290 57 83 196622 dspstate~;
#P objectname u921000001;
#P comment 214 178 282 196622 thresh = -1 dB \, t1 = 10 ms \, t2 = 70 ms;
#P window linecount 5;
#P comment 3 317 100 196622 failsafe if filter is overloaded: don't send out nan or inf;
#P window linecount 1;
#P comment 2 269 100 196622 filter out DC;
#P window linecount 4;
#P comment 6 162 100 196622 hard limiter: avoid prolonged hard clipping;
#P window linecount 1;
#P newex 110 372 68 196622 bitsafe~;
#N comlet signal output;
#P outlet 110 429 15 0;
#N comlet signal input;
#P inlet 110 70 15 0;
#P newex 110 264 202 196622 biquad~ 1. -1. 0. -0.9997 0.;
#P message 290 88 44 196622 clear;
#P comment 339 90 390 196622 resetting audio will clear any (unlikely) filter blowups;
#P newex 110 107 68 196622 bitsafe~;
#P window linecount 4;
#P comment 0 70 100 196622 don't send nan or inf to the limiter or filter;
#P window linecount 1;
#P comment 377 58 221 196622 reset filter on audio on/off;
#P connect 6 0 2 0;
#P connect 2 0 14 0;
#P connect 14 0 5 0;
#P connect 4 0 5 0;
#P connect 5 0 8 0;
#P connect 8 0 7 0;
#P connect 13 0 4 0;
#P connect 15 0 4 0;
#P pop;
